from __future__ import print_function
import pickle
import os

import matplotlib.pyplot as plt
from music21 import *

import DT

internalReducedFlag = False
capture = False
progs = [{}, {}]
output = stream.Score()
pTreb = stream.Part()
pBass = stream.Part()
lastChorale = 1
chorale = stream.Score()
analyzed_file = stream.Score()

"""
Get a histogram of notes occurring over a specific chord; a small program that is kind of instructive. 

TODO: 
	1. keep track of the doubling locations?

"""

def gather_stats(source = 'BACH', fileName = '', transposeBass = False):
	global progs, output, pTreb, pBass, lastChorale, chorale, analyzed_file, capture, internalReducedFlag, globalSource, globalTransposeBass, missingChords, upperVoicePositions, spacingChords, spacingDict
	globalSource = source.upper()
	globalTransposeBass = transposeBass
	missingChords = {}
	spacingDict = {}
	spacingChords = {}
	progs = {}
	upperVoicePositions = [{}, {}]
	if globalSource in DT._PATHS:
		analysisPath = DT._PATHS[globalSource][0]
		scorePath = DT._PATHS[globalSource][1]
		fileStr = globalSource
		files = os.listdir(analysisPath)
		recordResults = True
		counter = 0
		for myFile in files:
			if myFile[-3:] == 'txt':
				if fileName and fileName != myFile[:-4]:
					continue
				print('Analyzing', myFile)
				analyzed_file = converter.parse(analysisPath + myFile, format='romantext')
				try:
					chorale = converter.parse(scorePath + myFile.replace('.txt', '.xml'))
				except:
					try:
						chorale = converter.parse(scorePath + myFile.replace('.txt', '.krn'))
					except:
						continue
				dochorale(counter)
				counter += 1
		if not fileName:
			outputFile = open(DT._DATAPATH + 'chordscalehisto' + fileStr + '.pkl', 'wb')
			pickle.dump(progs, outputFile)
			outputFile.close()
	return

def load(source='Bach'):
	global globalSource, progs, missingChords, upperVoicePositions, spacingDict, spacingChords
	globalSource = source.upper()
	inputFile = open(DT._DATAPATH + 'chordscalehisto' + globalSource + '.pkl', 'rb')
	progs = pickle.load(inputFile)
	inputFile.close()

load("Bach")

def dochorale(n):
	global progs, output, pTreb, pBass, chorale, analyzed_file, globalTransposeBass, missingChords, upperVoicePositions, anal, score, spacingDict, spacingChords
	anal = analyzed_file.flat.getElementsByClass('RomanNumeral')																		# currently very kludgey
	score = chorale.flat.getElementsByClass(['Note', 'Chord'])
	for i in range(0, len(anal)):
		RN = anal[i]
		RNoffset = RN.offset																				# do this because offsets can change unpredictably
		RNpitchClasses = DT.fix_roman(RN)																	# repair the seventh too						
		RNbeat = RN.beat - 1
		chordLabel = RN.figure
		foundInstance = False
		foundBass = False
		chordalSkipError = False
		foundFourNoteChord = False
		isSeventh = False
		foundSeventh = False
		if RN.key.pitchAndMode[1] == 'minor':
			keyStr = str(RN.key.pitchAndMode[0]).lower() + ': '
			modeIndex = 1
		else:
			keyStr = str(RN.key.pitchAndMode[0]) + ': '
			modeIndex = 0
		chordString = keyStr + chordLabel												
		RNuniquePCs = set(RNpitchClasses)
		verts = score.getElementsByOffset(RNoffset + .01, RNoffset + RN.duration.quarterLength - .01, includeEndBoundary = False, mustBeginInSpan = False)
		for chord in verts:													# NOTE: was limiting to four voices, but that's bad for Palestrina
			myDuration = chord.duration.quarterLength
			if 'Chord' in chord.classes:
				for p in chord.pitches:
					p = p.midi
					record(chordString, p, myDuration)
			else:
				if 'Note' in chord.classes:
					p = chord.pitch.midi
					record(chordString, p, myDuration)
	return

def record(chordString, p, myDuration):
	global progs
	if chordString not in progs:
		progs[chordString] = {}
	if p % 12 not in progs[chordString]:
		progs[chordString][p % 12] = {}
	progs[chordString][p % 12][myDuration] = progs[chordString][p % 12].setdefault(myDuration, 0) + 1

def make_graph(myChord = 'C: I', mode = 'major', normalize = True):
	global progs, testDict
	
	modeIndex = (mode[1].upper() != 'A')
	
	output = [0] * 12
	
	
	testDict = {}
	
	if myChord.count(':') == 0:
		for sym in progs:
			symSplit = sym.split(': ')
			thisMode = sym[0][0].islower()
			if symSplit[1] == myChord and thisMode == modeIndex:
				transposeFactor = pc_from_letter(symSplit[0])
				for p in range(12):
					if p in progs[sym]:
						testDict[symSplit[0]] = transposeFactor
						output[(p - transposeFactor) % 12] = sum_dict(progs[sym][p])		
	else:	
		if normalize:
			transposeFactor = pc_from_letter(myChord.split()[0])
		else:
			transposeFactor = 0
		for p in range(12):
			if p in progs[myChord]:
				output[(p - transposeFactor) % 12] = sum_dict(progs[myChord][p])
	
	output = [1.0 * x/sum(output) for x in output]
	
	fig, ax = plt.subplots()
	opacity = 0.4
	bar_width = .4
	error_config = {'ecolor': '0.3'}

	rects1 = plt.bar(list(range(12)), output, bar_width,
	                 alpha=opacity,
	                 color='b')
	plt.xlabel('Pitch Classes')
	plt.ylabel('Duration')
	plt.title('Histogram of note durations')
	#plt.xticks(index + bar_width / 2, ('A', 'B', 'C', 'D', 'E'))
	plt.legend()

	#plt.tight_layout()
	plt.show()

def sum_dict(d):
	return sum([x * d[x] for x in d])

letterDict = 'C D EF G A B#-'
	
def pc_from_letter(l):
	l = l.upper()
	l = ''.join([x for x in l if x in letterDict])
	l = l.replace(' ', '')
	#print letterDict, 
	pc = letterDict.index(l[0])
	pc += l.count('#') + -1*l[1:].count('B') + -1*l[1:].count('-')
	return pc
	
	
	
	
