from __future__ import print_function
import random
import rn

"""
Simulate chord progressions based on first-order statistics.  Not really used anywhere.

"""

symbols = ['I', 'V', 'IV']
counts = [200, 150, 75]
outputTransitions = {}

def normalize():
	global normCounts
	normCounts = []
	temp = [100.*x/sum(counts) for x in counts]
	currentSum = 0
	for f in temp:
		normCounts.append(f + currentSum)
		currentSum += f
	
def get_chord():
	x = random.randrange(0, 101)
	for i in range(len(normCounts)):
		if normCounts[i] > x:
			break
	return symbols[i]

def make_trans(n):
	global outputTransitions
	outputTransitions = {}
	firstChord = get_chord()
	for i in range(n):
		secondChord = get_chord()
		if firstChord != secondChord:
			progStr = firstChord + ' -> ' + secondChord
			outputTransitions[progStr] = outputTransitions.setdefault(progStr, 0) + 1
			firstChord = secondChord

def grammaticality(comp = 'Bach', mode = 'Major', transitions=5000, printOut = False):
	global symbols, counts, outputTransitions
	modeStr = int(mode[:2].upper() == 'MI')
	rn.load(comp)
	trueGrammar = rn.grammar(mode, fauxbourdon = True, repeats=True, printOut = False)
	rn.get_size(1)
	symbols = []
	counts = []
	for item in rn.working[modeStr]:
		symbols.append(item)
		counts.append(rn.working[modeStr][item])
	normalize()
	make_trans(transitions)
	rn.counts[modeStr] = outputTransitions
	firstOrderComponent = rn.grammar(mode, fauxbourdon = True, repeats=True, printOut = printOut)
	print(firstOrderComponent, "percent out of", trueGrammar)
	return firstOrderComponent, trueGrammar
	
def load_probs(comp = 'Bach', removeInversions = True, mode = 'Major', transitions=5000, printOut = False):
	global symbols, counts, outputTransitions
	modeStr = int(mode[:2].upper() == 'MI')
	rn.load(comp)
	if removeInversions:
		rn.remove_inversions()
	rn.get_size(1)
	symbols = []
	counts = []
	for item in rn.working[modeStr]:
		symbols.append(item)
		counts.append(rn.working[modeStr][item])
	normalize()
	make_trans(transitions)

		
	
