"""comparison algorithm:

	1. same rhythm (optional)
	2. same pattern of harmonic and nhts 
	3. same pattern of chordal steps

"""

def interpret(inputNotes, targetChord, modulus = 12):
	chordTones = [x for x in inputNotes if (x % modulus) in targetChord]
	outputInterp = []
	outputHarmonic = []
	for i, n in enumerate(inputNotes):
		if n in chordTones: 
			outputHarmonic.append([n])
		foundNHT = True
		for NHTDist in [1, -1, 2, -2]:
			if (n+NHTDist) in chordTones:
				outputInterp.append([i, inputNotes.index(n+NHTDist), -1*NHTDist])
				foundNHT = True
				break
		if not foundNHT:
			return False
	return outputInterp, outputHarmonic

def chordal_steps(harmonicNotes, targetChord, modulus = 12):
	output = [0]
	chordLen = len(targetChord)
	for i, n2 in enumerate(harmonicNotes):
		if i == 0: 
			n1 = n2
			continue
		octaveDist = int((n2 - n1) / modulus)
		pc1 = targetChord.index(n1 % modulus)
		pc2 = targetChord.index(n2 % modulus)
		if octaveDist <= 0 and pc2 < pc1:
			octaveDist -= 1
		chordalDist = (pc2 - pc1) % chordLen
		output.append(chordalDist + (octaveDist*chordLen))
		n1 = n2
	return output