from __future__ import print_function
import os
import pickle
import time
from music21 import *
import DT


"""GETS THE BASIC INFO ON THE PALESTRINA CORPUS; should then be accessible just from the PALESTRINACORPUSDATA file"""

def get_palestrina_data(source = 'PALRAW', printOut = False):							# write something new for raw searching of XML, etc.
	global theTextFile
	source = source.upper()
	globalSource = source
	if source not in DT._PATHS:
		print("SOURCE NOT FOUND!")
		return
	analysisPath = DT._PATHS[source][0]
	scorePath = DT._PATHS[source][1]
	files = os.listdir(scorePath)
	startT = time.time()
	palestrinaData = {}
	
	counter = 1
	for myFile in files:
		if myFile[-3:] in ['xml', 'krn']:
			tempName = scorePath + myFile		#.replace('.txt', '.xml')
			if printOut: print('File', tempName)
			fileData = ['', '', '']
			with open(tempName, 'rb') as theTextFile:
				for line in theTextFile:
					line = str(line)
					if line.count('!!!'):
						line = line.replace('\\n', '').split('!!!')[1]	# OPR, PWK, YOR
						if line.startswith('OPR: '): fileData[0] = line[5:]
						if line.startswith('PWK: '): fileData[1] = line[5:]
						if line.startswith('YOR: '): fileData[2] = line[5:]
			palestrinaData[myFile] = fileData
	with open(DT._DATAPATH + 'PALESTRINACORPUSDATA.pkl', 'wb') as outputFile:
		pickle.dump(palestrinaData,outputFile)
	
	minutes = (time.time() - startT)/60.
	print('Total analysis took', int(minutes), 'minutes and %.0f seconds' % ((minutes - int(minutes)) * 60))
	return
