import os

import DT

import palcorpus
import rn
import vl
import reversals
import ranges
import nht
import chord_distributions
import progressions
import cadences
import doublings
import sd
import sd2
import cpt2
import cpt3
import overlap
import ouch
import renaissance_analyzer
import modulations
import phrase_and_melody
import raw_sequences

sourceDir = '/Users/dmitri/Source Code/Python/Music Data BACKUP'

defaultComposers = {'rn': ['SCHUTZ', 'RORE', 'VICTORIA', 'SCHEIN', 'BACH CHORALES', 'SERMISY', 'MENDELSSOHN', 'BACH CHORALES RAWMACHINE', 'LASSUS', 'BEETHOVEN', 'BRAHMS', 'TALLIS', 'WILLAERT2', 'MONTEVERDI', 
							'DALZA', 'LULLY', 'FROTTOLA', 'PALESTRINA', 'ROCK', 'MERULA',  'MORLEY', 'SACRED HARP', 'CORELLI', 'GOUDIMEL', 'MOZART', 'GOMBERT', 'JOSQUIN', 'CLEMENS', 'TALLIS2', 'CASTELLO', 
							'BACHINVENTIONS ANALYZED', 'WILLAERT', 'CAVALIERI', 'OCKEGHEM', 'DUFAY', 'CHOPIN', 'GASTOLDI', 'HAYDN',  'CAVALLI', 'ENCINA', 'BACH', 'BILL', 'PALESTRINA IONIAN'],
							
					'vl': ['FROTTOLA', 'PALESTRINA REDUCED', 'SERMISY', 'MORLEY', 'LULLY', 'WILLAERT2', 'BACH', 'LASSUS', 'TALLIS', 'VICTORIA', 'GOMBERT', 'ENCINA', 'CLEMENS', 'JOSQUIN', 'TALLIS2', 'GASTOLDI', 
							'CORELLI', 'RORE', 'WILLAERT', 'CAVALIERI', 'OCKEGHEM', 'BACH CHORALES REDUCED', 'MENDELSSOHN', 'PALESTRINA', 'CAVALLI', 'DUFAY', 'GOUDIMEL', 'MONTEVERDI'],
					
					'reversals': ['MORLEY', 'MENDELSSOHN', 'MOZART[0]', 'WTCF', 'LASSUS', 'SERMISY', 'ROCK', 'SACRED HARP', 'BACHINVENTIONS', 'PALESTRINA', 'PALRAW', 'MONTEVERDI', 'DUFAY',
								'BEETHOVEN QUARTETS[0]', 'JOSQUINCOMPLETE', 'GOMBERT', 'OCKEGHEM', 'WILLAERT', 'CLEMENS', 'JOSQUIN', 'CHOPIN', 'BEETHOVEN QUARTETS', 'CORELLI', 'BACH', 'CHOPIN[0]', 
								'MOZART', 'GOUDIMEL', 'HAYDN'],
					
					'ranges': ['OCKEGHEM', 'JOSQUINCOMPLETE', 'PALRAW', 'VICTORIARAW'],
					
					'chord_distributions': ['OCKEGHEM', 'JOSQUINCOMPLETE', 'PALRAW', 'VICTORIARAW'],
					
					'cadences': ['OCKEGHEM', 'JOSQUINCOMPLETE', 'PALRAW', 'VICTORIARAW'],
					
					'progressions': ['OCKEGHEM', 'JOSQUINCOMPLETE', 'PALRAW', 'VICTORIARAW'],
					
					'nht': ['GOMBERT', 'TALLIS2', 'CLEMENS', 'JOSQUIN', 'RORE', 'VICTORIA', 'MORLEY', 'CAVALIERI', 'DUFAY', 'ROCK', 'FROTTOLA', 'LASSUS', 'TALLIS', 'OCKEGHEM', 
							'WILLAERT', 'SERMISY', 'ENCINA', 'WILLAERT2', 'GOUDIMEL', 'BACH', 'PALESTRINA', 'MONTEVERDI', 'GASTOLDI'],
					
					'doublings': ['CORELLI', 'MENDELSSOHN', 'GOMBERT', 'PALESTRINA', 'TALLIS2', 'GASTOLDI', 'JOSQUIN', 'CLEMENS', 'WILLAERT2', 
								'LULLY', 'MONTEVERDI', 'MOZART', 'ENCINA', 'GOUDIMEL', 'CAVALLI', 'OCKEGHEM', 'WILLAERT', 'RORE', 'CASTELLO', 'TALLIS', 'BACH', 
								'LASSUS', 'SERMISY', 'SCHUTZ', 'CAVALIERI', 'FROTTOLA', 'MORLEY', 'VICTORIA', 'MERULA', 'DUFAY'],
					
					'sd2': ['MOZART'],
					
					'sd': ['GOUDIMEL', 'SERMISY', 'MERULA', 'CASTELLO', 'WILLAERT', 'OCKEGHEM', 'MORLEY', 'ROCK', 'GASTOLDI', 'RORE', 'LULLY', 'SCHUTZ', 'CAVALIERI', 'TALLIS', 
					'LASSUS', 'CORELLI', 'VICTORIA', 'GOMBERT', 'CLEMENS', 'JOSQUIN', 'DUFAY', 'TALLIS2', 'BACH', 'ENCINA', 'PALESTRINA', 
					'FROTTOLA', 'CAVALLI', 'HAYDN', 'CHOPIN', 'MONTEVERDI', 'WILLAERT2'],
					
					'cpt2': ['BACHINVENTIONS', 'PALRAW', 'OCKEGHEM', 'JOSQUINCOMPLETE', 'PALRAW', 'VICTORIARAW', 'LASSUSDUETS'],
					
					'cpt3': ['OCKEGHEM', 'JOSQUINCOMPLETE', 'PALRAW', 'VICTORIARAW'],
					
					'renaissance_analyzer': ['VICTORIARAW', 'JOSQUINCOMPLETE', 'PALRAW', 'OCKEGHEM'],
					
					'overlap': ['JOSQUINCOMPLETE', 'PALRAW', 'SACRED HARP', 'BACH CHORALES REDUCED', 'PALESTRINA', 'PALESTRINA REDUCED', 'FROTTOLA', 'MONTEVERDI', 'LASSUSDUETS', 'JOSQUIN', 'BACH', 'DUFAY', 'GOUDIMEL', 'OCKEGHEM'],
					
					'ouch': ['BACH', 'OCKEGHEM', 'GOUDIMEL', 'PALRAW', 'JOSQUINCOMPLETE', 'WTCF', 'MONTEVERDI', 'FROTTOLA', 'VICTORIARAW'],
					
					'modulations': ['CAVALIERI', 'MOZART', 'CHOPIN', 'VICTORIA', 'NOSECONDARIESPALESTRINA', 'LULLY', 'NOSECONDARIESROCK', 'SERMISY', 'WILLAERT2', 'NOSECONDARIESMORLEY', 'ROCK', 'ENCINA', 
					'WILLAERT', 'NOSECONDARIESMOZART', 'NOSECONDARIESBEETHOVEN', 'BEETHOVEN', 'CAVALLI', 'TALLIS', 'GOUDIMEL', 'NOSECONDARIESCHOPIN', 'MONTEVERDI', 'NOSECONDARIESBILL', 'NOSECONDARIESHAYDN', 
					'JOSQUIN', 'PALESTRINA', 'MORLEY', 'BACH', 'HAYDN', 'BILL', 'CORELLI'],
					
					'phrase_and_melody': ['PALESTRINA', 'MONTEVERDI', 'JOSQUIN', 'BACH'],
					
					'raw_sequences': ['CORELLI', 'WTC', 'MOZART']	
								
}

_DATAFILESTOSAVE = ['RAWSEQUENCESCATALOGUECORELLI.pkl', 'RAWSEQUENCESCATALOGUEMOZART.pkl', 'RAWSEQUENCESCATALOGUEWTC.pkl', 'tonalitysurvey.txt']

useStoredFileNames = True

errors = []

def erase_existing():
	theFiles = os.listdir(DT._DATAPATH)
	for f in sorted(theFiles):
		if f.startswith('.'): continue
		if f not in _DATAFILESTOSAVE:
			os.remove(DT._DATAPATH + f)

def remake_all(regenerate = True, erase = False):
	if erase:
		erase_existing()
	remake_human(regenerate = regenerate)
	remake_raw(regenerate = regenerate)

def remake_raw(regenerate = False):
	"""raw data"""
	if regenerate:
		palcorpus.get_palestrina_data(printOut = False)
	redo_reversals(regenerate = regenerate)
	for m in [ranges, chord_distributions, progressions, cadences, cpt2, cpt3, overlap, ouch, renaissance_analyzer]:
		redo_module(m, regenerate = regenerate)

def remake_human(regenerate = False):
	"""interpreted data"""
	for m in [rn, vl, nht, doublings, sd, sd2, phrase_and_melody, raw_sequences]:
		redo_module(m, regenerate = regenerate)
	redo_modulations(regenerate = regenerate)
	
	if regenerate:
		phrase_and_melody.load("Bach")
		phrase_and_melody.save_histo_dict()
		phrase_and_melody.make_markov()
	
	load_module("classical_analyzer")
	classical_analyzer.update_chord_frequencies()
	
	print("Remaking bass and root dictionaries")
	rn.load("Bach")
	rn.get_size(2)
	rn.make_bass_dict(writeOut = True)
	rn.get_size(2)
	rn.make_root_dict(writeOut = True)

def automatic_bach_analysis():
	load_module('analyzer')
	load_module('rn')
	load_module('eighthnote_harmonies')
	analyzer.gather_stats('Bach chorales Rawmachine', raw = True, overwrite = True)
	rn.gather_stats("Bach chorales Rawmachine")
	eighthnote_harmonies.gather_stats('Bach Chorales RAWMACHINE')
	analyzer.gather_stats('Bach chorales cleanmachine', raw = False, overwrite = True)

def redo_reversals(regenerate = True):
	global errors
	print('checking data files for reversa;s.py')
	if useStoredFileNames:
		complist = defaultComposers['reversals']
	else:
		complist = get_composer_list('reversals')
		print('reversals composers: ', complist)
	for c in complist:
		result = reversals.load(c)
		#print(c, result)
		if not result:
			if regenerate:
				if c.count('['):
					cSplit = c.split('[')
					c = cSplit[0]
					partList = [0]
				else:
					partList = []
				print('reversals.py: gathering data for', c)
				try:
					reversals.gather_stats(c, partLimit = partList)
				except:
					print("-----> ERROR WITH COMPOSER", c, "REVERSALS <----------")
					errors.append('reversals.py: ' + c)
			else:
				print('reversals.py: no data for', c)

def redo_modulations(regenerate = True):
	global errors
	print('checking data files for modulations.py')
	if useStoredFileNames:
		complist = defaultComposers['modulations']
	else:
		complist = get_composer_list('MODULATIONS')
		print('modulations composers: ', complist)
	for c in complist:
		result = modulations.load(c)
		if not result:
			if regenerate:
				if c.count('NOSECONDARIES'):
					secondaries = False
					c = c.replace('NOSECONDARIES', '')
				else:
					secondaries = True
				print('   modulations.py: gathering data for', c)
				try:
					modulations.gather_stats(c, secondaryDominants = secondaries)
				except:
					print("-----> ERROR WITH COMPOSER", c, "MODULATIONS <----------")
					errors.append('modulations.py: ' + c)
			else:
				print('   modulations.py: no data for', c)

def redo_module(module, header = '', regenerate = True):
	global errors
	mName = module.__name__
	if not header:
		header = mName.upper()
	print('checking data files for', mName+'.py')
	if useStoredFileNames:
		complist = defaultComposers[mName]
	else:
		complist = get_composer_list(header)
		print(mName, 'composers: ', complist)
	for c in complist:
		result = module.load(c)
		if (not result) or mName == 'renaissance_analyzer':
			if regenerate:
				print('   ', mName + '.py: gathering data for', c)
				try:
					module.gather_stats(c)
				except:
					print("-----> ERROR WITH COMPOSER", c, mName.upper() + " <----------")
					errors.append(mName+'.py: ' + c)
			else:
				if mName == 'renaissance_analyzer':
					print('   ', mName + '.py: may need data for ' +c + '.  Run gather_stats to check.')
				else:
					print('   ', mName + '.py: no data for', c)

def get_composer_list(prefix = 'VL', suffix = '.pkl'):
	l = os.listdir(sourceDir)
	return [x.replace(suffix, '').replace(prefix, '') for x in l if x.endswith(suffix) and x.startswith(prefix)]

def load_module(s):
	if s not in globals():
		globals()[s] = __import__(s)

"""======= RENAME ALL OLD DATA FILES TO NEW CONVENTIONS; SHOULDN'T BE NEEDED AFTER A WHILE ======="""

renameList = [['ALL_melodydegrees', 'SD2'], ['ALL_melodydegrees2', 'SD2'], ['RAWPROGRESSIONS', 'PROGRESSIONS'], ['RENAISSANCEANALYZER', 'RENAISSANCE_ANALYZER'], ['doublings', 'DOUBLINGS'],
['RENcadences', 'CADENCES'], ['CHORDDISTRIBUTIONS', 'CHORD_DISTRIBUTIONS'], ['reversals', 'REVERSALS'], ['nhtonecounts', 'NHT'], ['voiceleading', 'VL'], ['ALL_progressions', 'RN'], 
['overlap', 'OVERLAP'], ['modulations', 'MODULATIONS'], ['outervoicecounts', 'PHRASE_AND_MELODY']]

def new_names():
	os.chdir(DT._DATAPATH)
	for old, new in renameList:
		rename_files(old, new)

def rename_files(startStr = 'RED', replaceStr = ''):
	fNames = [x for x in os.listdir('.') if x.startswith(startStr)]
	theDir = list(reversed(sorted(fNames)))
	fNames = []
	for s in theDir:
		if startStr not in s: continue
		fNames.append([s, s.replace(startStr, replaceStr)])
	for oldName, newName in fNames:
		print(oldName, '\t', newName)
		if newName not in theDir:
			os.rename(oldName, newName)
			theDir.remove(oldName)
		else:
			print("FILE ALREADY EXISTS:", oldName, newName)