from __future__ import print_function
import pickle
import os
from music21 import *
import DT

internalReducedFlag = False
capture = False
locations = []
counts = {}
output = stream.Score()
pTreb = stream.Part()
pBass = stream.Part()
lastChorale = 1
chorale = stream.Score()
analyzed_file = stream.Score()

#inputFile = open(DT._DATAPATH + 'doublings.pkl', 'rb')
#progs = pickle.load(inputFile)
#inputFile.close()

"""

Find sevenths that don't resolve down by step (dochorale), or aren't prepared (dochorale2).

For resolutions, use reduced chorales.  For preparations used unreduced (since NH tones often prepare sevenths).

Should work in two modes, either 'preparations' or 'resolutions'

"""

def unresolved_sevenths():
	gather_stats("BACHRED")

def unprepared_sevenths():
	gather_stats("BACH")

def gather_stats(source = 'BACH', mode = 'resolution', useReduced = 'default'):
	global locations, internalReducedFlag, lastChorale, analyzed_file, chorale, output, counts, globalSource, globalFileName
	globalSource = source.upper()
	if mode[0:1].upper() == 'P':
		examinePreparations = True
		internalReducedFlag = False
	else:
		examinePreparations = False
		internalReducedFlag = True
	if globalSource not in DT._PATHS:
		print("Source not found!")
		return
	analysisPath = DT._PATHS[globalSource][0]
	scorePath = DT._PATHS[globalSource][1]
	fileStr = globalSource
	files = os.listdir(analysisPath)
	files = sorted([x for x in files if x[-3:] == 'txt'])
	counts = {}
	for i, f in enumerate(files):
		print('Analyzing', f)
		analyzed_file = converter.parse(analysisPath + f, format='romantext')
		chorale = converter.parse(scorePath + f.replace('txt', 'xml'))					
		if examinePreparations:
			dochorale2(i)
		else:
			dochorale(i)
	#output = DT.two_staves(output)
	#output.show()
	return

def dochorale(n):
	global locations, chorale, analyzed_file, output
	chorale_notes = []
	anal = analyzed_file.flat.getElementsByClass('RomanNumeral')
	size = len(chorale.parts)
	for i in range(0, size):
		chorale_notes.append(chorale.parts[i].flat.getElementsByClass('Note').stream())
	skipNextRN = False
	for i in range(1, len(anal) - 1):
		if skipNextRN:
			skipNextRN = False
			continue
		RN = anal[i]
		RNpitchClasses = DT.fix_roman(RN)																	# repair the seventh too
		if not RN.seventh: continue
		#print RN.figure
		seventh = DT.fix_roman.seventh
		RNoffset = RN.offset
		RNduration = RN.duration.quarterLength
		nextRN = anal[i+1]
		nextRNpitchClasses = DT.fix_roman(nextRN)
		nextRNoffset = nextRN.offset
		if sorted(RNpitchClasses) == sorted(nextRNpitchClasses):
			if i != len(anal) - 1:
				RNduration += nextRN.duration.quarterLength
				nextRN = anal[i+2]
				nextRNpitchClasses = DT.fix_roman(nextRN)
				nextRNoffset = nextRN.offset
				skipNextRN = True
		foundResolution = False
		commonTone = False
		foundSeventh = False
		for part in chorale_notes:
			notes = part.getElementsByOffset(RNoffset, RNoffset + RNduration, mustBeginInSpan = False, includeEndBoundary=False, includeElementsThatEndAtStart = False, classList =['Note'])
			if not notes: continue
			linePitches = notes.pitches
			#linePCs = [x.pitchClass for x in linePitches]
			p = [x.midi for x in linePitches if x.pitchClass == seventh]			
			if not p: continue
			foundSeventh = True
			resolution = part.getElementsByOffset(RNoffset + RNduration, nextRNoffset + nextRN.duration.quarterLength, mustBeginInSpan = False, includeEndBoundary=False, includeElementsThatEndAtStart = False, classList =['Note'])
			if not resolution:
				print("PROBLEM!", n)
				continue
			resolutionChordMidi = [x.pitch.midi for x in resolution if x.pitch.pitchClass in nextRNpitchClasses]
			if not resolutionChordMidi:
				continue
			startNote = p[0]
			resNote = resolutionChordMidi[0]
			if resNote == startNote: commonTone = True
#					print RN.figure, RNoffset, startNote, resolution.pitches, RNoffset + RNduration, nextRNoffset + nextRN.duration.quarterLength
			if (startNote - resNote) == 1 or (startNote - resNote) == 2: 
				foundResolution = True
#						print RN.figure, startNote, resNote
			else:
				pass										# activate following line to get EVERY unresolved seventh
#						print "Unresolved Seventh", n, DT.get_measure_number_and_beat_from_offset(chorale, RN.offset)
		if not foundSeventh: continue
		if not foundResolution and not commonTone:
			myMeas, myBeat = DT.get_measure_number_and_beat_from_offset(chorale, RN.offset)
			message = RN.figure + " -> " + nextRN.figure
			print("    Leapt-away seventh, chorale", DT.get_measure_number_and_beat_from_offset(chorale, RN.offset), RN.figure,"->", nextRN.figure)
		if not foundResolution and commonTone: 
			pass
			#print "    CT seventh, chorale", DT.get_measure_number_and_beat_from_offset(chorale, RN.offset), RN.figure,"->", nextRN.figure
	return
	
def dochorale2(n):
	global locations, chorale, analyzed_file, output, counts
	chorale_notes = []
	anal = analyzed_file.flat.getElementsByClass('RomanNumeral')
	size = len(chorale.parts)
	for i in range(0, size):
		chorale_notes.append(chorale.parts[i].flat.getElementsByClass('Note').stream())
	for i in range(1, len(anal) - 1):
		RN = anal[i]
		RNpitchClasses = DT.fix_roman(RN)																	# repair the seventh too
		if not RN.seventh: continue
#		print RN.figure
		seventh = DT.fix_roman.seventh
		RNoffset = RN.offset
		RNduration = RN.duration.quarterLength
		prevRN = anal[i-1]
		prevRNpitchClasses = DT.fix_roman(prevRN)
		prevRNoffset = prevRN.offset
		"""if sorted(RNpitchClasses) == sorted(prevRNpitchClasses):
			if i != len(anal) - 1:
				RNduration += prevRN.duration.quarterLength
				prevRN = anal[i+2]
				prevRNpitchClasses = DT.fix_roman(prevRN)
				prevRNoffset = prevRN.offset"""
		foundPreparation = False
		commonTone = False
		for part in chorale_notes:
			notes = part.getElementsByOffset(RNoffset, RNoffset + RNduration, mustBeginInSpan = False, includeEndBoundary=False, includeElementsThatEndAtStart = False, classList =['Note'])
			if not notes: continue
			linePitches = notes.pitches
			for p in linePitches:
				if p.pitchClass != seventh: continue
				preparation = part.getElementBeforeOffset(RNoffset, classList =['Note'])
				if not preparation:
					print("PROBLEM!", n)
					continue
				else:
					endNote = p.midi
					prepNote = preparation.midi
					prepInt = prepNote - endNote
					prepIntStr = str(prepInt)
					if abs(prepInt) <= 2: 
						foundPreparation = True
						counts[prepIntStr] = counts.setdefault(prepIntStr, 0) +  1 
		if not foundPreparation:
			myMeas, myBeat = DT.get_measure_number_and_beat_from_offset(chorale, prevRNoffset)
			message = prevRN.figure + " -> " + RN.figure
			print("Unprepared seventh, chorale", n, DT.get_measure_number_and_beat_from_offset(chorale, prevRN.offset), prevRN.figure + " -> " + RN.figure)
	return